'use strict';

var _chai = require('chai');

var _loadInfo = require('../loadInfo');

var _loadInfo2 = _interopRequireDefault(_loadInfo);

var _timekeeper = require('timekeeper');

var _timekeeper2 = _interopRequireDefault(_timekeeper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('loadInfo', function () {
  it('loads the current date', function () {
    var now = Date.now();
    _timekeeper2.default.freeze(now);

    return (0, _loadInfo2.default)().then(function (data) {
      (0, _chai.expect)(data).to.deep.equal({ time: now, message: 'This came from the api server' });
    });
  });
});