'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  Icon: {
    displayName: 'Icon'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/Icon/Icon.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var Icon = _wrapComponent('Icon')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(Icon, _Component);

  function Icon() {
    (0, _classCallCheck3.default)(this, Icon);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Icon).apply(this, arguments));
  }

  (0, _createClass3.default)(Icon, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      // Should only update if icon name changes
      return nextProps.iconName !== this.props.iconName;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('Icon:cDU - ' + this.props.iconName);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var iconName = _props.iconName;
      var viewBox = _props.viewBox;

      var iconId = '#icon-' + iconName;
      return _react3.default.createElement(
        'svg',
        { viewBox: viewBox || '0 0 1024 1024' },
        _react3.default.createElement('use', { xlinkHref: iconId })
      );
    }
  }]);
  return Icon;
}(_react2.Component), _class.propTypes = {
  iconName: _react2.PropTypes.string.isRequired,
  viewBox: _react2.PropTypes.string
}, _temp));

exports.default = Icon;
module.exports = exports['default'];