'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _LoadingSpinner = require('./LoadingSpinner.scss');

var _LoadingSpinner2 = _interopRequireDefault(_LoadingSpinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LoadingSpinner: {
    displayName: 'LoadingSpinner'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/LoadingSpinner/LoadingSpinner.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

// TODO ## Remove this temporary disable
/* eslint react/no-unknown-property:0 */

var LoadingSpinner = _wrapComponent('LoadingSpinner')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(LoadingSpinner, _Component);

  function LoadingSpinner() {
    (0, _classCallCheck3.default)(this, LoadingSpinner);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LoadingSpinner).apply(this, arguments));
  }

  (0, _createClass3.default)(LoadingSpinner, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      // Should only update if icon name changes
      return nextProps.size !== this.props.size || nextProps.strokeWidth !== this.props.strokeWidth;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('LoadingSpinner:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var size = _props.size;
      var strokeWidth = _props.strokeWidth;

      return _react3.default.createElement(
        'article',
        { className: _LoadingSpinner2.default.loadingSpinner, style: { height: size + 'px', width: size + 'px' } },
        _react3.default.createElement(
          'svg',
          { style: { height: size + 'px', width: size + 'px' } },
          _react3.default.createElement('circle', { className: 'path', cx: size / 2, cy: size / 2, r: size / 2 - 4 * strokeWidth, fill: 'none', strokeWidth: strokeWidth || 2, strokeMiterlimit: '10' })
        )
      );
    }
  }]);
  return LoadingSpinner;
}(_react2.Component), _class.propTypes = {
  size: _react2.PropTypes.number,
  strokeWidth: _react2.PropTypes.number
}, _temp));

exports.default = LoadingSpinner;
module.exports = exports['default'];