'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp;

var _LogManagementPageLogPanel = require('./LogManagementPageLogPanel.scss');

var _LogManagementPageLogPanel2 = _interopRequireDefault(_LogManagementPageLogPanel);

var _components2 = require('../../components');

var _classnames7 = require('classnames');

var _classnames8 = _interopRequireDefault(_classnames7);

var _logs = require('../../redux/modules/logs');

var _reactRedux = require('react-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogManagementPageLogPanel: {
    displayName: 'LogManagementPageLogPanel'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/LogManagementPageLogPanel/LogManagementPageLogPanel.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var LogManagementPageLogPanel = _wrapComponent('LogManagementPageLogPanel')((_dec = (0, _reactRedux.connect)(null, { toggleDeleteLogOpen: _logs.toggleDeleteLogOpen, deleteLog: _logs.deleteLog, toggleEditOpen: _logs.toggleEditOpen, setEditedName: _logs.setEditedName, setEditedGroup: _logs.setEditedGroup, setEditedFile: _logs.setEditedFile, setEditedPath: _logs.setEditedPath, saveLogChanges: _logs.saveLogChanges }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(LogManagementPageLogPanel, _Component);

  function LogManagementPageLogPanel() {
    (0, _classCallCheck3.default)(this, LogManagementPageLogPanel);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LogManagementPageLogPanel).apply(this, arguments));
  }

  (0, _createClass3.default)(LogManagementPageLogPanel, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  Should only update if IDs, name, file name, file path, activeState,
       *  hasNew or listFilter change
       */
      return this.props.groupName !== nextProps.groupName || this.props.groupId !== nextProps.groupId || this.props.logId !== nextProps.logId || this.props.log.name !== nextProps.log.name || this.props.log.editPanelOpen !== nextProps.log.editPanelOpen || this.props.log.editSaving !== nextProps.log.editSaving || this.props.log.editedName !== nextProps.log.editedName || this.props.log.editedGroup !== nextProps.log.editedGroup || this.props.log.editedFile !== nextProps.log.editedFile || this.props.log.editedPath !== nextProps.log.editedPath || this.props.log.deletePanelOpen !== nextProps.log.deletePanelOpen || this.props.log.deleteSaving !== nextProps.log.deleteSaving;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('LogManagementPageLogPanel:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var groupName = _props.groupName;
      var groupId = _props.groupId;
      var logId = _props.logId;
      var log = _props.log;
      var groupOptionsList = _props.groupOptionsList;
      var toggleEditOpen = _props.toggleEditOpen;
      var setEditedName = _props.setEditedName;
      var setEditedGroup = _props.setEditedGroup;
      var setEditedPath = _props.setEditedPath;
      var setEditedFile = _props.setEditedFile;
      var saveLogChanges = _props.saveLogChanges;
      var toggleDeleteLogOpen = _props.toggleDeleteLogOpen;
      var deleteLog = _props.deleteLog; // eslint-disable-line

      return _react3.default.createElement(
        'div',
        { className: (0, _classnames8.default)(_LogManagementPageLogPanel2.default.logManagementPageLogPanel, (0, _defineProperty3.default)({}, _LogManagementPageLogPanel2.default.formOpen, log.editPanelOpen)) },
        _react3.default.createElement(
          'div',
          { className: _LogManagementPageLogPanel2.default.basePanel },
          _react3.default.createElement(
            'div',
            { className: _LogManagementPageLogPanel2.default.lhs },
            _react3.default.createElement(
              'p',
              null,
              log.name
            ),
            _react3.default.createElement(
              'p',
              null,
              _react3.default.createElement(
                'span',
                null,
                'File:'
              ),
              _react3.default.createElement(
                'span',
                { title: log.fname },
                log.fname
              )
            ),
            _react3.default.createElement(
              'p',
              null,
              _react3.default.createElement(
                'span',
                null,
                'Path:'
              ),
              _react3.default.createElement(
                'span',
                { title: log.fpath },
                log.fpath
              )
            ),
            groupName && _react3.default.createElement(
              'p',
              null,
              _react3.default.createElement(
                'span',
                null,
                'Group:'
              ),
              _react3.default.createElement(
                'span',
                null,
                groupName
              )
            )
          ),
          _react3.default.createElement(
            'div',
            { className: _LogManagementPageLogPanel2.default.actions },
            _react3.default.createElement(
              'button',
              { onClick: function onClick() {
                  return toggleEditOpen(logId);
                } },
              _react3.default.createElement(_components2.Icon, { iconName: 'pencil' })
            ),
            _react3.default.createElement(
              'button',
              { onClick: function onClick() {
                  return toggleDeleteLogOpen(logId);
                } },
              _react3.default.createElement(_components2.Icon, { iconName: 'delete' })
            )
          )
        ),
        _react3.default.createElement(
          'div',
          { className: (0, _classnames8.default)(_LogManagementPageLogPanel2.default.formContainer, _LogManagementPageLogPanel2.default.fadeInPanel, (0, _defineProperty3.default)({}, _LogManagementPageLogPanel2.default.open, log.editPanelOpen)) },
          _react3.default.createElement(
            'div',
            { className: _LogManagementPageLogPanel2.default.lhs },
            _react3.default.createElement(
              'form',
              { onSubmit: function onSubmit(event) {
                  saveLogChanges(logId, log.name, groupId, log.editedName, log.editedGroup, log.editedFile, log.editedPath);event.preventDefault();return false;
                } },
              _react3.default.createElement('input', { type: 'text', placeholder: 'New log name', maxLength: '15', value: log.editedName, onChange: function onChange(event) {
                  return setEditedName(logId, event.target.value);
                } }),
              _react3.default.createElement(_components2.DropDown, { customClassName: (0, _classnames8.default)(_LogManagementPageLogPanel2.default.selectStyling, (0, _defineProperty3.default)({}, _LogManagementPageLogPanel2.default.placeholderColour, log.editedGroup === '-1')), options: groupOptionsList, initialValue: log.editedGroup || groupId, onChange: function onChange(event) {
                  return setEditedGroup(logId, event.target.value);
                } }),
              _react3.default.createElement('input', { type: 'text', placeholder: 'File name', maxLength: '1000', value: log.editedFile, onChange: function onChange(event) {
                  return setEditedFile(logId, event.target.value);
                } }),
              _react3.default.createElement('input', { type: 'text', placeholder: 'File location', maxLength: '1000', value: log.editedPath, onChange: function onChange(event) {
                  return setEditedPath(logId, event.target.value);
                } })
            )
          ),
          _react3.default.createElement(
            'div',
            { className: _LogManagementPageLogPanel2.default.actions },
            _react3.default.createElement(
              'button',
              { onClick: function onClick() {
                  return saveLogChanges(logId, log.name, groupId, log.editedName, log.editedGroup, log.editedFile, log.editedPath);
                } },
              _react3.default.createElement(_components2.Icon, { iconName: 'check' })
            ),
            _react3.default.createElement(
              'button',
              { onClick: function onClick() {
                  return toggleEditOpen(logId);
                } },
              _react3.default.createElement(_components2.Icon, { iconName: 'close' })
            )
          )
        ),
        _react3.default.createElement(
          'div',
          { className: (0, _classnames8.default)(_LogManagementPageLogPanel2.default.savingPanel, _LogManagementPageLogPanel2.default.fadeInPanel, (0, _defineProperty3.default)({}, _LogManagementPageLogPanel2.default.open, log.editSaving)) },
          _react3.default.createElement(_components2.LoadingSpinner, { size: 24, strokeWidth: 1 }),
          _react3.default.createElement(
            'p',
            null,
            'Saving...'
          )
        ),
        _react3.default.createElement(
          'div',
          { className: (0, _classnames8.default)(_LogManagementPageLogPanel2.default.deleteCheckPanel, _LogManagementPageLogPanel2.default.fadeInPanel, (0, _defineProperty3.default)({}, _LogManagementPageLogPanel2.default.open, log.deletePanelOpen)) },
          _react3.default.createElement(
            'div',
            { className: _LogManagementPageLogPanel2.default.lhs },
            _react3.default.createElement(
              'p',
              null,
              'Are you sure you want to delete log: "',
              log.name,
              '"'
            )
          ),
          _react3.default.createElement(
            'div',
            { className: _LogManagementPageLogPanel2.default.actions },
            _react3.default.createElement(
              'button',
              { onClick: function onClick() {
                  return deleteLog(groupId, logId, log.name);
                } },
              _react3.default.createElement(_components2.Icon, { iconName: 'check' })
            ),
            _react3.default.createElement(
              'button',
              { onClick: function onClick() {
                  return toggleDeleteLogOpen(logId);
                } },
              _react3.default.createElement(_components2.Icon, { iconName: 'close' })
            )
          )
        ),
        _react3.default.createElement(
          'div',
          { className: (0, _classnames8.default)(_LogManagementPageLogPanel2.default.deletingPanel, _LogManagementPageLogPanel2.default.fadeInPanel, (0, _defineProperty3.default)({}, _LogManagementPageLogPanel2.default.open, log.deleteSaving)) },
          _react3.default.createElement(_components2.LoadingSpinner, { size: 24, strokeWidth: 1 }),
          _react3.default.createElement(
            'p',
            null,
            'Deleting...'
          )
        )
      );
    }
  }]);
  return LogManagementPageLogPanel;
}(_react2.Component), _class2.propTypes = {
  groupName: _react2.PropTypes.string,
  groupId: _react2.PropTypes.string.isRequired,
  logId: _react2.PropTypes.string.isRequired,
  log: _react2.PropTypes.object.isRequired,
  groupOptionsList: _react2.PropTypes.array,
  toggleEditOpen: _react2.PropTypes.func.isRequired,
  setEditedName: _react2.PropTypes.func.isRequired,
  setEditedGroup: _react2.PropTypes.func.isRequired,
  setEditedFile: _react2.PropTypes.func.isRequired,
  setEditedPath: _react2.PropTypes.func.isRequired,
  saveLogChanges: _react2.PropTypes.func.isRequired,
  toggleDeleteLogOpen: _react2.PropTypes.func.isRequired,
  deleteLog: _react2.PropTypes.func.isRequired
}, _temp)) || _class));

exports.default = LogManagementPageLogPanel;
module.exports = exports['default'];