'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp;

var _components2 = require('../../components');

var _NotificationArea = require('./NotificationArea.scss');

var _NotificationArea2 = _interopRequireDefault(_NotificationArea);

var _reactRedux = require('react-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  NotificationArea: {
    displayName: 'NotificationArea'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/NotificationArea/NotificationArea.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var NotificationArea = _wrapComponent('NotificationArea')((_dec = (0, _reactRedux.connect)(function (state) {
  return { notifications: state.notifications.list };
}), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(NotificationArea, _Component);

  function NotificationArea() {
    (0, _classCallCheck3.default)(this, NotificationArea);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(NotificationArea).apply(this, arguments));
  }

  (0, _createClass3.default)(NotificationArea, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return nextProps.notifications.length !== this.props.notifications.length;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('NotificationArea:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var notifications = this.props.notifications;

      return _react3.default.createElement(
        'div',
        { className: _NotificationArea2.default.notificationArea },
        notifications.map(function (notification, index) {
          return _react3.default.createElement(_components2.Notification, { key: notification.id, notification: notification, position: index });
        })
      );
    }
  }]);
  return NotificationArea;
}(_react2.Component), _class2.propTypes = {
  notifications: _react2.PropTypes.array.isRequired
}, _temp)) || _class));

exports.default = NotificationArea;
module.exports = exports['default'];