'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _dec2, _class, _class2, _temp;

var _appManagement = require('../../redux/modules/appManagement');

var _connectData = require('../../helpers/connectData');

var _connectData2 = _interopRequireDefault(_connectData);

var _reactRedux = require('react-redux');

var _components2 = require('../../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  AppManagement: {
    displayName: 'AppManagement'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/containers/AppManagement/AppManagement.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

function fetchData(getState, dispatch) {
  if (!(0, _appManagement.isLoaded)(getState())) {
    return dispatch((0, _appManagement.load)());
  }
}

var AppManagement = _wrapComponent('AppManagement')((_dec = (0, _connectData2.default)(fetchData), _dec2 = (0, _reactRedux.connect)(function (state) {
  return {
    system: state.appManagement.data,
    saving: state.appManagement.saving
  };
}), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(AppManagement, _Component);

  function AppManagement() {
    (0, _classCallCheck3.default)(this, AppManagement);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(AppManagement).apply(this, arguments));
  }

  (0, _createClass3.default)(AppManagement, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var system = _props.system;
      var saving = _props.saving;

      return _react3.default.createElement(_components2.AppManagementPage, { system: system, saving: saving });
    }
  }]);
  return AppManagement;
}(_react2.Component), _class2.propTypes = {
  system: _react2.PropTypes.object.isRequired,
  saving: _react2.PropTypes.bool
}, _temp)) || _class) || _class));

exports.default = AppManagement;
module.exports = exports['default'];