'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _dec2, _class, _class2, _temp;

var _appInterface = require('../../redux/modules/appInterface');

var _groups = require('../../redux/modules/groups');

var _logs = require('../../redux/modules/logs');

var _connectData = require('../../helpers/connectData');

var _connectData2 = _interopRequireDefault(_connectData);

var _reactRedux = require('react-redux');

var _components2 = require('../../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  DashboardHome: {
    displayName: 'DashboardHome'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/containers/DashboardHome/DashboardHome.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

function fetchData(getState, dispatch) {
  var promises = [];
  if (!(0, _groups.isLoaded)(getState())) {
    promises.push(dispatch((0, _groups.load)()));
  }
  if (!(0, _logs.isLoaded)(getState())) {
    promises.push(dispatch((0, _logs.load)()));
  }
  return _promise2.default.all(promises);
}

var DashboardHome = _wrapComponent('DashboardHome')((_dec = (0, _connectData2.default)(fetchData), _dec2 = (0, _reactRedux.connect)(function (state) {
  return {
    dashboardListFilter: state.appInterface.dashboardListFilter,
    groups: state.groups.data,
    logs: state.logs.data
  };
}, { setDashboardListFilter: _appInterface.setDashboardListFilter }), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(DashboardHome, _Component);

  function DashboardHome() {
    (0, _classCallCheck3.default)(this, DashboardHome);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(DashboardHome).apply(this, arguments));
  }

  (0, _createClass3.default)(DashboardHome, [{
    key: 'render',
    value: function render() {
      return _react3.default.createElement(_components2.DashboardPage, this.props);
    }
  }]);
  return DashboardHome;
}(_react2.Component), _class2.propTypes = {
  dashboardListFilter: _react2.PropTypes.string,
  setDashboardListFilter: _react2.PropTypes.func,
  groups: _react2.PropTypes.object.isRequired,
  logs: _react2.PropTypes.object.isRequired
}, _temp)) || _class) || _class));

exports.default = DashboardHome;
module.exports = exports['default'];