'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

exports.default = connectData;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  ConnectData: {
    displayName: 'ConnectData',
    isInFunction: true
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/helpers/connectData.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

/*
  Note:
    When this decorator is used, it MUST be the first (outermost) decorator.
    Otherwise, we cannot find and call the fetchData and fetchDataDeffered methods.
*/

/*
  fetchData block a server-side request until the data is loaded/received
  whereas fetchDataDeferred continues to render as the data is being fetched
  and is usually loaded on the client side.
*/

function connectData(fetchData, fetchDataDeferred) {
  return function wrapWithFetchData(WrappedComponent) {
    var _class, _temp;

    var ConnectData = _wrapComponent('ConnectData')((_temp = _class = function (_Component) {
      (0, _inherits3.default)(ConnectData, _Component);

      function ConnectData() {
        (0, _classCallCheck3.default)(this, ConnectData);
        return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(ConnectData).apply(this, arguments));
      }

      (0, _createClass3.default)(ConnectData, [{
        key: 'render',
        value: function render() {
          return _react3.default.createElement(WrappedComponent, this.props);
        }
      }]);
      return ConnectData;
    }(_react2.Component), _class.fetchData = fetchData, _class.fetchDataDeferred = fetchDataDeferred, _temp));

    return ConnectData;
  };
}
module.exports = exports['default'];