'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _AdminPage = require('./AdminPage.scss');

var _AdminPage2 = _interopRequireDefault(_AdminPage);

var _reactRouter = require('react-router');

var _config = require('../../config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  AdminPage: {
    displayName: 'AdminPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/AdminPage/AdminPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var AdminPage = _wrapComponent('AdminPage')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(AdminPage, _Component);

  function AdminPage() {
    (0, _classCallCheck3.default)(this, AdminPage);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(AdminPage).apply(this, arguments));
  }

  (0, _createClass3.default)(AdminPage, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('AdminPage:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      return _react3.default.createElement(
        'section',
        { className: _AdminPage2.default.adminPage },
        _react3.default.createElement(
          'header',
          null,
          _react3.default.createElement(
            'div',
            { className: _AdminPage2.default.row },
            _react3.default.createElement(
              'h2',
              null,
              'Settings'
            )
          ),
          _react3.default.createElement(
            'div',
            { className: _AdminPage2.default.row },
            _react3.default.createElement(
              'nav',
              null,
              _react3.default.createElement(
                'ul',
                null,
                _react3.default.createElement(
                  'li',
                  null,
                  _react3.default.createElement(
                    _reactRouter.Link,
                    { to: '/dashboard/settings/groups', activeClassName: _AdminPage2.default.active },
                    'Groups'
                  )
                ),
                _react3.default.createElement(
                  'li',
                  null,
                  _react3.default.createElement(
                    _reactRouter.Link,
                    { to: '/dashboard/settings/logs', activeClassName: _AdminPage2.default.active },
                    'Logs'
                  )
                ),
                _react3.default.createElement(
                  'li',
                  null,
                  _react3.default.createElement(
                    _reactRouter.Link,
                    { to: '/dashboard/settings/app', activeClassName: _AdminPage2.default.active },
                    'App'
                  )
                ),
                _config.releaseStage > 0 ? _react3.default.createElement(
                  'li',
                  null,
                  _react3.default.createElement(
                    _reactRouter.Link,
                    { to: '/dashboard/admin/users', activeClassName: _AdminPage2.default.active },
                    'Users'
                  )
                ) : null,
                _config.releaseStage > 2 ? _react3.default.createElement(
                  'li',
                  null,
                  _react3.default.createElement(
                    _reactRouter.Link,
                    { to: '/dashboard/admin/syntax', activeClassName: _AdminPage2.default.active },
                    'Syntax'
                  )
                ) : null
              )
            )
          )
        ),
        this.props.children
      );
    }
  }]);
  return AdminPage;
}(_react2.Component), _class.propTypes = {
  children: _react2.PropTypes.object.isRequired
}, _temp));

exports.default = AdminPage;
module.exports = exports['default'];