'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _AnalysisPage = require('./AnalysisPage.scss');

var _AnalysisPage2 = _interopRequireDefault(_AnalysisPage);

var _components2 = require('../../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  AnalysisPage: {
    displayName: 'AnalysisPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/AnalysisPage/AnalysisPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var AnalysisPage = _wrapComponent('AnalysisPage')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(AnalysisPage, _Component);

  function AnalysisPage() {
    (0, _classCallCheck3.default)(this, AnalysisPage);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(AnalysisPage).apply(this, arguments));
  }

  (0, _createClass3.default)(AnalysisPage, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('AnalysisPage:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var logData = _props.logData;
      var logLevelMapping = _props.logLevelMapping;

      var contents = undefined;
      if (logLevelMapping) {
        console.log('Performing analysis');
        console.log(!!logData);
        contents = _react3.default.createElement('ul', null);
      } else {
        contents = _react3.default.createElement(
          'article',
          { className: _AnalysisPage2.default.fullPageError },
          _react3.default.createElement(_components2.Icon, { iconName: 'alert-circle' }),
          _react3.default.createElement(
            'div',
            null,
            _react3.default.createElement(
              'h3',
              null,
              'No log syntax set'
            ),
            _react3.default.createElement(
              'p',
              null,
              'You must set a syntax matcher on the log so that the analysis tool can detect and count which lines are errors, debug messages, etc...'
            )
          )
        );
      }

      return _react3.default.createElement(
        'section',
        { className: _AnalysisPage2.default.analysisPage },
        contents
      );
    }
  }]);
  return AnalysisPage;
}(_react2.Component), _class.propTypes = {
  groupId: _react2.PropTypes.string,
  logId: _react2.PropTypes.string,
  logData: _react2.PropTypes.array,
  logLevelMapping: _react2.PropTypes.object
}, _temp));

exports.default = AnalysisPage;
module.exports = exports['default'];