'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _ControlButton = require('./ControlButton.scss');

var _ControlButton2 = _interopRequireDefault(_ControlButton);

var _components2 = require('../../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  ControlButton: {
    displayName: 'ControlButton'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/ControlButton/ControlButton.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var ControlButton = _wrapComponent('ControlButton')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(ControlButton, _Component);

  function ControlButton() {
    (0, _classCallCheck3.default)(this, ControlButton);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(ControlButton).apply(this, arguments));
  }

  (0, _createClass3.default)(ControlButton, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  This component should only update if the iconName, text, color or
       *  onClick change.
       */
      return this.props.iconName !== nextProps.iconName || this.props.text !== nextProps.text || this.props.color !== nextProps.color || this.props.onClick !== nextProps.onClick || this.props.isDisabled !== nextProps.isDisabled;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('ControlButton:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var iconName = _props.iconName;
      var text = _props.text;
      var color = _props.color;
      var onClick = _props.onClick;
      var isDisabled = _props.isDisabled;

      var colorClass = color ? _ControlButton2.default[color] : _ControlButton2.default.neutral;
      return _react3.default.createElement(
        'button',
        { className: _ControlButton2.default.controlButton + ' ' + colorClass, onClick: onClick, disabled: isDisabled, 'aria-label': text },
        _react3.default.createElement(_components2.Icon, { iconName: iconName }),
        _react3.default.createElement(
          'span',
          null,
          text
        )
      );
    }
  }]);
  return ControlButton;
}(_react2.Component), _class.propTypes = {
  iconName: _react2.PropTypes.string,
  text: _react2.PropTypes.string.isRequired,
  color: _react2.PropTypes.string,
  onClick: _react2.PropTypes.func, // ##TODO Make this required
  isDisabled: _react2.PropTypes.bool
}, _temp));

exports.default = ControlButton;
module.exports = exports['default'];