'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _GroupNotFoundPage = require('./GroupNotFoundPage.scss');

var _GroupNotFoundPage2 = _interopRequireDefault(_GroupNotFoundPage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  GroupNotFoundPage: {
    displayName: 'GroupNotFoundPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/GroupNotFoundPage/GroupNotFoundPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var GroupNotFoundPage = _wrapComponent('GroupNotFoundPage')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(GroupNotFoundPage, _Component);

  function GroupNotFoundPage() {
    (0, _classCallCheck3.default)(this, GroupNotFoundPage);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(GroupNotFoundPage).apply(this, arguments));
  }

  (0, _createClass3.default)(GroupNotFoundPage, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return nextProps.groupId !== this.props.groupId;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('GroupNotFoundPage:cDU - ' + this.props.groupId);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react3.default.createElement(
        'section',
        { className: _GroupNotFoundPage2.default.groupNotFoundPage },
        _react3.default.createElement(_reactHelmet2.default, { title: 'Group Not Found' }),
        _react3.default.createElement(
          'h2',
          null,
          'Group not found.'
        ),
        _react3.default.createElement(
          'p',
          null,
          'No group exists for the ID "',
          this.props.groupId,
          '". The group may have been deleted or you may have entered an incorrect URL.'
        )
      );
    }
  }]);
  return GroupNotFoundPage;
}(_react2.Component), _class.propTypes = {
  groupId: _react2.PropTypes.string.isRequired
}, _temp));

exports.default = GroupNotFoundPage;
module.exports = exports['default'];