'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _LogNotFoundPage = require('./LogNotFoundPage.scss');

var _LogNotFoundPage2 = _interopRequireDefault(_LogNotFoundPage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogNotFoundPage: {
    displayName: 'LogNotFoundPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/LogNotFoundPage/LogNotFoundPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var LogNotFoundPage = _wrapComponent('LogNotFoundPage')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(LogNotFoundPage, _Component);

  function LogNotFoundPage() {
    (0, _classCallCheck3.default)(this, LogNotFoundPage);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LogNotFoundPage).apply(this, arguments));
  }

  (0, _createClass3.default)(LogNotFoundPage, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return nextProps.logId !== this.props.logId;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('LogNotFoundPage:cDU - ' + this.props.logId);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react3.default.createElement(
        'section',
        { className: _LogNotFoundPage2.default.logNotFoundPage },
        _react3.default.createElement(_reactHelmet2.default, { title: 'Log Not Found' }),
        _react3.default.createElement(
          'h2',
          null,
          'Log not found.'
        ),
        _react3.default.createElement(
          'p',
          null,
          'No log exists for the ID "',
          this.props.logId,
          '". The log may have been deleted or you may have entered an incorrect URL.'
        )
      );
    }
  }]);
  return LogNotFoundPage;
}(_react2.Component), _class.propTypes = {
  logId: _react2.PropTypes.string.isRequired
}, _temp));

exports.default = LogNotFoundPage;
module.exports = exports['default'];