'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp2;

var _LogOutputPage = require('./LogOutputPage.scss');

var _LogOutputPage2 = _interopRequireDefault(_LogOutputPage);

var _reactRedux = require('react-redux');

var _logs = require('../../redux/modules/logs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogOutputPage: {
    displayName: 'LogOutputPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/LogOutputPage/LogOutputPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var LogOutputPage = _wrapComponent('LogOutputPage')((_dec = (0, _reactRedux.connect)(null, { setLogRead: _logs.setLogRead }), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(LogOutputPage, _Component);

  function LogOutputPage() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, LogOutputPage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(LogOutputPage)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.componentDidUpdate = function () {
      console.log('LogOutputPage:cDU');
      var _this$props = _this.props;
      var logId = _this$props.logId;
      var setLogRead = _this$props.setLogRead;
      var scrollLocked = _this$props.scrollLocked; // eslint-disable-line no-shadow

      if (scrollLocked) {
        _this.refs.scrollArea.scrollTop = _this.refs.scrollArea.scrollHeight;
      }
      setLogRead(logId);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(LogOutputPage, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props;
      var logId = _props.logId;
      var setLogRead = _props.setLogRead; // eslint-disable-line no-shadow

      setLogRead(logId);
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      /*  Should only update if IDs, scrollLocked or logData changes. Log data
       *  array is only ever changed by pushing to or reseting the whole array.
       *  Given this it is safe to simply check the array length.
       */
      return this.props.logId !== nextProps.logId || this.props.scrollLocked !== nextProps.scrollLocked || this.props.logData.length !== nextProps.logData.length;
    }
  }, {
    key: 'render',
    value: function render() {
      var logData = this.props.logData;

      return _react3.default.createElement(
        'section',
        { ref: 'scrollArea', className: _LogOutputPage2.default.logOutputPage },
        _react3.default.createElement(
          'ol',
          null,
          logData.map(function (line, index) {
            return _react3.default.createElement(
              'li',
              { key: index },
              index
            );
          })
        ),
        _react3.default.createElement(
          'ol',
          { style: { paddingLeft: logData.length.toString().length * 8 + 15 + 'px' } },
          logData && logData.map(function (line, index) {
            return _react3.default.createElement(
              'li',
              { key: index },
              _react3.default.createElement(
                'div',
                null,
                line
              )
            );
          })
        )
      );
    }
  }]);
  return LogOutputPage;
}(_react2.Component), _class2.propTypes = {
  logId: _react2.PropTypes.string.isRequired,
  logData: _react2.PropTypes.array.isRequired,
  setLogRead: _react2.PropTypes.func.isRequired,
  scrollLocked: _react2.PropTypes.bool.isRequired
}, _temp2)) || _class));

exports.default = LogOutputPage;
module.exports = exports['default'];