'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _LogPage = require('./LogPage.scss');

var _LogPage2 = _interopRequireDefault(_LogPage);

var _components2 = require('../../components');

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogPage: {
    displayName: 'LogPage'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/LogPage/LogPage.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var LogPage = _wrapComponent('LogPage')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(LogPage, _Component);

  function LogPage() {
    (0, _classCallCheck3.default)(this, LogPage);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LogPage).apply(this, arguments));
  }

  (0, _createClass3.default)(LogPage, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      console.log('LogPage:cDU');
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var logId = _props.logId;
      var log = _props.log; // eslint-disable-line no-shadow

      return _react3.default.createElement(
        'section',
        { className: _LogPage2.default.logPage },
        _react3.default.createElement(_reactHelmet2.default, { title: log.name }),
        _react3.default.createElement(_components2.LogPageHeader, { logId: logId, log: log }),
        this.props.children
      );
    }
  }]);
  return LogPage;
}(_react2.Component), _class.propTypes = {
  logId: _react2.PropTypes.string.isRequired,
  log: _react2.PropTypes.object.isRequired,
  children: _react2.PropTypes.object.isRequired
}, _temp));

exports.default = LogPage;
module.exports = exports['default'];