'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  SvgStore: {
    displayName: 'SvgStore'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/components/SvgStore/SvgStore.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

// TODO ## Remove this temporary disable
/* eslint react/no-unknown-property:0 */

var SvgStore = _wrapComponent('SvgStore')(function (_Component) {
  (0, _inherits3.default)(SvgStore, _Component);

  function SvgStore() {
    (0, _classCallCheck3.default)(this, SvgStore);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(SvgStore).apply(this, arguments));
  }

  (0, _createClass3.default)(SvgStore, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      // Should never update, doesn't receive any props
      return false;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react3.default.createElement(
        'div',
        null,
        _react3.default.createElement(
          'svg',
          { style: { position: 'absolute', width: 0, height: 0 }, width: '0', height: '0', version: '1.1', xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink' },
          _react3.default.createElement(
            'defs',
            null,
            _react3.default.createElement(
              'symbol',
              { id: 'icon-logger-logo', viewBox: '0 0 123.1 34' },
              _react3.default.createElement(
                'title',
                null,
                'logger-logo'
              ),
              _react3.default.createElement('path', { d: 'M0 25.874V0h5.977v20.626h12.537v5.248H0zm29.19.364c-1.627 0-3.08-.268-4.354-.802-1.276-.534-2.35-1.257-3.225-2.17-.87-.91-1.53-1.966-1.98-3.17-.45-1.2-.67-2.46-.67-3.77 0-1.312.23-2.57.68-3.772.45-1.203 1.11-2.26 1.99-3.17.88-.91 1.95-1.64 3.23-2.187 1.28-.546 2.73-.82 4.36-.82 1.63 0 3.08.273 4.34.82 1.27.547 2.34 1.276 3.21 2.187.88.91 1.54 1.968 2.01 3.17s.69 2.46.69 3.772c0 1.312-.224 2.57-.673 3.77-.45 1.204-1.116 2.26-1.99 3.17-.875.913-1.95 1.636-3.225 2.17s-2.73.802-4.36.802zm-4.263-9.912c0 1.506.4 2.715 1.203 3.625.802.92 1.822 1.37 3.06 1.37.608 0 1.168-.12 1.678-.36s.954-.58 1.33-1.02.675-.96.893-1.58c.22-.62.33-1.29.33-2.02 0-1.5-.4-2.71-1.2-3.62-.8-.91-1.81-1.36-3.02-1.36-.6 0-1.17.13-1.69.37s-.97.58-1.35 1.02c-.37.44-.67.97-.89 1.59-.22.62-.32 1.29-.32 2.02zm24.816 9.62c-1.264 0-2.417-.255-3.462-.765-1.04-.51-1.93-1.2-2.67-2.07-.74-.87-1.32-1.89-1.73-3.06-.41-1.16-.62-2.41-.62-3.75 0-1.41.22-2.71.66-3.91.44-1.2 1.05-2.25 1.82-3.13.78-.88 1.71-1.58 2.81-2.09s2.3-.76 3.61-.76c1.46 0 2.73.31 3.81.93s1.95 1.48 2.61 2.57V6.74h5.07v17.82c0 1.458-.27 2.77-.82 3.936-.55 1.167-1.31 2.157-2.28 2.97s-2.14 1.44-3.5 1.878c-1.36.436-2.85.654-4.48.654-2.06 0-3.83-.327-5.28-.983s-2.73-1.603-3.83-2.844L44.57 27c.705.803 1.58 1.44 2.624 1.914 1.044.476 2.162.71 3.353.71.704 0 1.372-.097 2.004-.29.63-.194 1.19-.492 1.68-.893.49-.4.87-.92 1.15-1.56.28-.64.42-1.41.42-2.31V22.7c-.58 1.07-1.42 1.88-2.51 2.426-1.09.546-2.27.82-3.53.82zm2.005-4.63c.9 0 1.7-.246 2.405-.744s1.25-1.136 1.64-1.914v-4.01c-.39-1.02-.983-1.827-1.785-2.422s-1.652-.893-2.55-.893c-.633 0-1.21.14-1.732.42-.522.28-.972.655-1.35 1.128-.376.48-.667 1.03-.874 1.65-.207.62-.31 1.26-.31 1.92 0 .71.116 1.36.347 1.95.23.6.55 1.11.96 1.55.41.44.89.78 1.44 1.02.54.24 1.14.37 1.8.37zm21.32 4.63c-1.264 0-2.42-.255-3.464-.765s-1.938-1.2-2.678-2.07c-.743-.87-1.32-1.89-1.73-3.06-.414-1.16-.62-2.41-.62-3.75 0-1.41.218-2.71.656-3.91.436-1.2 1.044-2.25 1.82-3.13.78-.88 1.714-1.58 2.808-2.09 1.092-.51 2.296-.76 3.607-.76 1.457 0 2.726.31 3.81.93 1.08.62 1.948 1.48 2.603 2.57V6.74h5.066v17.82c0 1.458-.274 2.77-.82 3.936-.547 1.167-1.306 2.157-2.276 2.97-.974.814-2.14 1.44-3.5 1.878-1.36.436-2.854.654-4.48.654-2.065 0-3.827-.327-5.286-.983-1.457-.656-2.733-1.603-3.826-2.844L67.892 27c.705.803 1.58 1.44 2.624 1.914 1.045.476 2.16.71 3.354.71.703 0 1.37-.097 2.004-.29.633-.194 1.19-.492 1.677-.893.49-.4.87-.92 1.15-1.56.28-.64.42-1.41.42-2.31V22.7c-.58 1.07-1.42 1.88-2.51 2.426-1.09.546-2.27.82-3.53.82zm2.002-4.63c.898 0 1.7-.246 2.405-.744.704-.498 1.252-1.136 1.64-1.914v-4.01c-.388-1.02-.983-1.827-1.785-2.422s-1.652-.893-2.55-.893c-.632 0-1.21.14-1.732.42-.523.28-.97.655-1.348 1.128-.377.48-.67 1.03-.875 1.65-.206.62-.31 1.26-.31 1.92 0 .71.115 1.36.347 1.95.23.6.55 1.11.965 1.55s.895.78 1.44 1.02 1.15.37 1.803.37zm23.034 4.922c-1.604 0-3.044-.262-4.318-.783-1.277-.522-2.357-1.233-3.244-2.133-.888-.898-1.562-1.937-2.022-3.115-.462-1.178-.692-2.41-.692-3.7 0-1.384.23-2.69.692-3.916.46-1.22 1.128-2.3 2.003-3.22.875-.92 1.95-1.65 3.227-2.18 1.274-.53 2.727-.8 4.355-.8 1.627 0 3.072.27 4.336.81 1.27.54 2.34 1.26 3.21 2.17.88.91 1.54 1.96 1.99 3.15.45 1.19.68 2.44.68 3.76 0 .34-.01.68-.03 1-.02.33-.06.62-.11.86H94.03c.096 1.29.565 2.268 1.4 2.936.84.666 1.79 1 2.86 1 .85 0 1.67-.204 2.46-.62.79-.41 1.318-.97 1.586-1.674l4.96 1.386c-.755 1.507-1.92 2.73-3.5 3.68-1.58.95-3.476 1.424-5.684 1.424zm4.042-11.734c-.12-1.215-.558-2.174-1.312-2.88-.753-.704-1.688-1.056-2.805-1.056-1.15 0-2.09.36-2.83 1.075-.74.717-1.17 1.67-1.3 2.86h8.23zm20.957-2.77c-1.41.024-2.686.256-3.827.693s-1.968 1.093-2.478 1.968v11.48h-5.832V6.74h5.356v3.863c.658-1.288 1.5-2.296 2.535-3.025 1.03-.73 2.13-1.105 3.297-1.13h.583c.12 0 .242.013.365.038v5.246z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-alert-circle', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'alert-circle'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M733.7 563.2h-102.4v-307.2h102.4zM733.7 768h-102.4v-102.4h102.4zM682.5 0c-282.624 0-512 229.376-512 512s229.376 512 512 512 512-229.376 512-512-229.376-512-512-512z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-account', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'account'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M682.5-0.001c141.44 0 256.001 114.56 256.001 256.001s-114.56 256.001-256.001 256.001-256.001-114.56-256.001-256.001 114.56-256.001 256.001-256.001zM682.5 639.999c282.88 0 512 114.56 512 256.001v128h-1024v-128c0-141.44 229.12-256.001 512-256.001z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-chevron-down', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'chevron-down'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M160.26 89.886l522.24 522.24 522.24-522.24 160.426 161.564-682.667 682.667-682.667-682.667 160.426-161.564z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-key-variant', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'key-variant'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M1194.5 819.2v204.8h-204.8v-153.6h-153.6v-153.6h-153.6l-115.712-115.712c-28.16 8.704-57.856 13.312-89.088 13.312-169.472 0-307.2-137.728-307.2-307.2s137.728-307.2 307.2-307.2 307.2 137.728 307.2 307.2c0 31.232-4.608 60.928-13.312 89.088l422.912 422.912zM426.5 153.599c-56.32 0-102.4 46.080-102.4 102.4s46.080 102.4 102.4 102.4 102.4-46.080 102.4-102.4-46.080-102.4-102.4-102.4z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-magnify', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'magnify'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M550.841 0c210.066 0 380.343 170.277 380.343 380.343 0 94.208-34.523 180.81-91.283 247.516l15.799 15.799h46.226l292.571 292.571-87.771 87.771-292.571-292.571v-46.226l-15.799-15.799c-66.706 56.759-153.308 91.283-247.516 91.283-210.066 0-380.343-170.277-380.343-380.343s170.277-380.343 380.343-380.343zM550.841 117.027c-146.286 0-263.314 117.029-263.314 263.314s117.029 263.314 263.314 263.314 263.314-117.029 263.314-263.314-117.029-263.314-263.314-263.314z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-pause', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'pause'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M828.786 1024h292.572v-1024h-292.572zM243.643 1024h292.572v-1024h-292.572v1024z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-play', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'play'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M280.241 0v1024l804.572-512-804.572-512z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-settings', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'settings'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M682.755 691.2c-98.816 0-179.2-80.384-179.2-179.2s80.384-179.2 179.2-179.2 179.2 80.384 179.2 179.2-80.384 179.2-179.2 179.2zM1063.17 561.664c2.048-16.384 3.584-32.768 3.584-49.664s-1.536-33.792-3.584-51.2l108.032-83.456c9.728-7.68 12.288-21.504 6.144-32.768l-102.4-177.152c-6.144-11.264-19.968-15.872-31.232-11.264l-127.487 51.2c-26.624-19.968-54.272-37.376-86.528-50.176l-18.944-135.68c-2.048-12.288-12.8-21.504-25.6-21.504h-204.8c-12.8 0-23.552 9.216-25.6 21.504l-18.944 135.68c-32.256 12.8-59.904 30.208-86.528 50.176l-127.487-51.2c-11.264-4.608-25.088 0-31.232 11.264l-102.4 177.152c-6.656 11.264-3.584 25.088 6.144 32.768l108.032 83.456c-2.048 17.408-3.584 34.304-3.584 51.2s1.536 33.28 3.584 49.664l-108.032 84.992c-9.728 7.68-12.8 21.504-6.144 32.768l102.4 177.152c6.144 11.264 19.968 15.36 31.232 11.264l127.487-51.712c26.624 20.48 54.272 37.888 86.528 50.688l18.944 135.68c2.048 12.288 12.8 21.504 25.6 21.504h204.8c12.8 0 23.552-9.216 25.6-21.504l18.944-135.68c32.256-13.312 59.904-30.208 86.528-50.688l127.487 51.712c11.264 4.096 25.088 0 31.232-11.264l102.4-177.152c6.144-11.264 3.584-25.088-6.144-32.768l-108.032-84.992z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-stop', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'stop'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M1194.501 1023.999h-1024v-1024h1024v1024z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-menu-down', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'menu-down'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M-0.165 170.667l682.666 682.666 682.666-682.666h-1365.333z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-lock', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'lock'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M682.501 780.19c53.638 0 97.524-43.886 97.524-97.524 0-54.126-43.886-97.524-97.524-97.524s-97.524 43.886-97.524 97.524 43.886 97.524 97.524 97.524zM975.072 341.333c53.638 0 97.524 43.886 97.524 97.524v487.619c0 53.638-43.886 97.524-97.524 97.524h-585.143c-53.638 0-97.524-43.886-97.524-97.524v-487.619c0-54.126 43.886-97.524 97.524-97.524h48.762v-97.524c0-134.583 109.227-243.809 243.809-243.809s243.809 109.227 243.809 243.809v97.524h48.762zM682.501 97.524c-80.945 0-146.286 65.341-146.286 146.286v97.524h292.571v-97.524c0-80.945-65.341-146.286-146.286-146.286z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-lock-open', viewBox: '0 0 1349 1024' },
              _react3.default.createElement(
                'title',
                null,
                'lock-open'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M967.075 341.333c53.638 0 97.524 43.886 97.524 97.524v487.619c0 53.638-43.886 97.524-97.524 97.524h-585.143c-54.126 0-97.524-43.886-97.524-97.524v-487.619c0-53.638 43.886-97.524 97.524-97.524h438.857v-97.524c0-80.945-65.341-146.286-146.286-146.286s-146.286 65.341-146.286 146.286h-97.524c0-134.583 109.227-243.809 243.809-243.809s243.809 109.227 243.809 243.809v97.524h48.762zM674.504 780.19c53.638 0 97.524-43.886 97.524-97.524s-43.886-97.524-97.524-97.524-97.524 43.886-97.524 97.524 43.886 97.524 97.524 97.524z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-keyboard-backspace', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'keyboard-backspace'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M1365.167 436.148h-1074.821l271.549-272.308-106.951-106.951-455.111 455.111 455.111 455.111 106.951-107.709-271.549-271.549h1074.821v-151.704z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-arrow-left', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'arrow-left'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M1194.501 447.353v129.293h-775.758l355.556 355.556-91.798 91.798-512-512 512-512 91.798 91.798-355.556 355.556h775.758z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-delete', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'delete'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M1080.722 56.889h-199.111l-56.889-56.889h-284.444l-56.889 56.889h-199.111v113.778h796.444zM341.166 910.222c0 62.578 51.2 113.778 113.778 113.778h455.111c62.578 0 113.778-51.2 113.778-113.778v-682.667h-682.667v682.667z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-logout', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'logout'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M967.111 981.333v-184.889h-398.222v-227.556h398.222v-184.889l298.667 298.667-298.667 298.667zM739.556 113.778c62.578 0 113.778 51.2 113.778 113.778v227.556h-113.778v-227.556h-512v910.222h512v-227.556h113.778v227.556c0 62.578-51.2 113.778-113.778 113.778h-512c-62.578 0-113.778-51.2-113.778-113.778v-910.222c0-62.578 51.2-113.778 113.778-113.778h512z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-content-save', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'content-save'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M853.167 341.334h-568.888v-227.556h568.888zM682.501 910.223c-94.436 0-170.667-76.231-170.667-170.667s76.231-170.667 170.667-170.667 170.667 76.231 170.667 170.667-76.231 170.667-170.667 170.667zM966.945 0.002h-682.666c-63.147 0-113.778 51.2-113.778 113.778v796.443c0 62.578 51.2 113.778 113.778 113.778h796.443c62.578 0 113.778-51.2 113.778-113.778v-682.666l-227.556-227.556z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-close', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'close'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M1194.5 103.131l-103.131-103.131-408.869 408.869-408.869-408.869-103.131 103.131 408.869 408.869-408.869 408.869 103.131 103.131 408.869-408.869 408.869 408.869 103.131-103.131-408.869-408.869 408.869-408.869z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-plus', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'plus'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M1194.5 585.143h-438.857v438.857h-146.286v-438.857h-438.857v-146.286h438.857v-438.857h146.286v438.857h438.857v146.286z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-pencil', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'pencil'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M1172.436 234.219c22.064-22.064 22.064-58.837 0-79.77l-132.385-132.385c-20.933-22.064-57.706-22.064-79.77 0l-104.098 103.532 212.155 212.155zM170.499 811.845v212.155h212.155l625.715-626.281-212.155-212.155-625.715 626.281z' })
            ),
            _react3.default.createElement(
              'symbol',
              { id: 'icon-check', viewBox: '0 0 1365 1024' },
              _react3.default.createElement(
                'title',
                null,
                'check'
              ),
              _react3.default.createElement('path', { className: 'path1', d: 'M1350.665 107.668l-916.333 916.333-419.986-419.986 107.669-107.669 312.317 311.554 808.663-807.899 107.669 107.669z' })
            )
          )
        )
      );
    }
  }]);
  return SvgStore;
}(_react2.Component));

exports.default = SvgStore;
module.exports = exports['default'];