'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp;

var _groups = require('../../redux/modules/groups');

var _groupManagement = require('../../redux/modules/groupManagement');

var _reactRedux = require('react-redux');

var _components2 = require('../../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  GroupManagement: {
    displayName: 'GroupManagement'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/containers/GroupManagement/GroupManagement.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var GroupManagement = _wrapComponent('GroupManagement')((_dec = (0, _reactRedux.connect)(function (state) {
  return {
    groups: state.groups.data,
    newGroupControls: state.groupManagement
  };
}, { toggleEditNameOpen: _groups.toggleEditNameOpen, toggleDeleteGroupOpen: _groups.toggleDeleteGroupOpen, setEditedName: _groups.setEditedName, saveGroupName: _groups.saveGroupName, deleteGroup: _groups.deleteGroup, setNewGroupName: _groupManagement.setNewGroupName, toggleInputingNewGroup: _groupManagement.toggleInputingNewGroup, createNewGroup: _groupManagement.createNewGroup }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(GroupManagement, _Component);

  function GroupManagement() {
    (0, _classCallCheck3.default)(this, GroupManagement);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(GroupManagement).apply(this, arguments));
  }

  (0, _createClass3.default)(GroupManagement, [{
    key: 'render',
    value: function render() {
      return _react3.default.createElement(_components2.GroupManagementPage, this.props);
    }
  }]);
  return GroupManagement;
}(_react2.Component), _class2.propTypes = {
  groups: _react2.PropTypes.object.isRequired,
  newGroupControls: _react2.PropTypes.object.isRequired,
  toggleEditNameOpen: _react2.PropTypes.func.isRequired,
  toggleDeleteGroupOpen: _react2.PropTypes.func.isRequired,
  setEditedName: _react2.PropTypes.func.isRequired,
  saveGroupName: _react2.PropTypes.func.isRequired,
  deleteGroup: _react2.PropTypes.func.isRequired,
  setNewGroupName: _react2.PropTypes.func.isRequired,
  toggleInputingNewGroup: _react2.PropTypes.func.isRequired,
  createNewGroup: _react2.PropTypes.func.isRequired
}, _temp)) || _class));

exports.default = GroupManagement;
module.exports = exports['default'];