'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _class, _class2, _temp;

var _logManagement = require('../../redux/modules/logManagement');

var _reactRedux = require('react-redux');

var _components2 = require('../../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogManagement: {
    displayName: 'LogManagement'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/containers/LogManagement/LogManagement.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

var LogManagement = _wrapComponent('LogManagement')((_dec = (0, _reactRedux.connect)(function (state) {
  return {
    groups: state.groups.data,
    logs: state.logs.data,
    logManagementState: state.logManagement
  };
}, { toggleSortByGroup: _logManagement.toggleSortByGroup, toggleInputingNewGroup: _logManagement.toggleInputingNewGroup, setNewLogName: _logManagement.setNewLogName, setNewLogGroup: _logManagement.setNewLogGroup, setNewLogFile: _logManagement.setNewLogFile, setNewLogPath: _logManagement.setNewLogPath, createNewLog: _logManagement.createNewLog }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(LogManagement, _Component);

  function LogManagement() {
    (0, _classCallCheck3.default)(this, LogManagement);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LogManagement).apply(this, arguments));
  }

  (0, _createClass3.default)(LogManagement, [{
    key: 'render',
    value: function render() {
      return _react3.default.createElement(_components2.LogManagementPage, this.props);
    }
  }]);
  return LogManagement;
}(_react2.Component), _class2.propTypes = {
  groups: _react2.PropTypes.object.isRequired,
  logs: _react2.PropTypes.object.isRequired,
  logManagementState: _react2.PropTypes.object.isRequired,
  toggleSortByGroup: _react2.PropTypes.func.isRequired,
  toggleInputingNewGroup: _react2.PropTypes.func.isRequired,
  setNewLogName: _react2.PropTypes.func.isRequired,
  setNewLogGroup: _react2.PropTypes.func.isRequired,
  setNewLogFile: _react2.PropTypes.func.isRequired,
  setNewLogPath: _react2.PropTypes.func.isRequired
}, _temp)) || _class));

exports.default = LogManagement;
module.exports = exports['default'];