'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _dec, _dec2, _class, _class2, _temp;

var _logs = require('../../redux/modules/logs');

var _connectData = require('../../helpers/connectData');

var _connectData2 = _interopRequireDefault(_connectData);

var _reactRedux = require('react-redux');

var _components2 = require('../../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  LogOutput: {
    displayName: 'LogOutput'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/containers/LogOutput/LogOutput.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

function fetchData(getState, dispatch) {
  if (!(0, _logs.isLoaded)(getState())) {
    return dispatch((0, _logs.load)());
  }
}

var LogOutput = _wrapComponent('LogOutput')((_dec = (0, _connectData2.default)(fetchData), _dec2 = (0, _reactRedux.connect)(function (state) {
  return {
    log: state.logs.data[state.router.params.logId],
    logId: state.router.params.logId
  };
}), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(LogOutput, _Component);

  function LogOutput() {
    (0, _classCallCheck3.default)(this, LogOutput);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LogOutput).apply(this, arguments));
  }

  (0, _createClass3.default)(LogOutput, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var log = _props.log;
      var logId = _props.logId;

      return !!logId && !!log && _react3.default.createElement(_components2.LogOutputPage, { logId: logId, logData: log.logData, scrollLocked: log.scrollLocked });
    }
  }]);
  return LogOutput;
}(_react2.Component), _class2.propTypes = {
  // Can't be `isRequired` because the logId dissappears when the log is remotely deleted
  log: _react2.PropTypes.object,
  logId: _react2.PropTypes.string
}, _temp)) || _class) || _class));

exports.default = LogOutput;
module.exports = exports['default'];