'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _redux = require('redux');

var _reduxRouter = require('redux-router');

var _appInterface = require('./appInterface');

var _appInterface2 = _interopRequireDefault(_appInterface);

var _auth = require('./auth');

var _auth2 = _interopRequireDefault(_auth);

var _groups = require('./groups');

var _groups2 = _interopRequireDefault(_groups);

var _logs = require('./logs');

var _logs2 = _interopRequireDefault(_logs);

var _notifications = require('./notifications');

var _notifications2 = _interopRequireDefault(_notifications);

var _groupManagement = require('./groupManagement');

var _groupManagement2 = _interopRequireDefault(_groupManagement);

var _logManagement = require('./logManagement');

var _logManagement2 = _interopRequireDefault(_logManagement);

var _appManagement = require('./appManagement');

var _appManagement2 = _interopRequireDefault(_appManagement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _redux.combineReducers)({
  router: _reduxRouter.routerStateReducer,
  appInterface: _appInterface2.default,
  auth: _auth2.default,
  groups: _groups2.default,
  logs: _logs2.default,
  notifications: _notifications2.default,
  groupManagement: _groupManagement2.default,
  logManagement: _logManagement2.default,
  appManagement: _appManagement2.default
});
module.exports = exports['default'];